openapi: 3.1.0
info:
  title: Gcore OpenAPI – CDN API
  description: This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS Protection, Object Storage, Streaming, and FastEdge services.
  version: e8ce2320eb58
servers:
- url: https://api.gcore.com
tags:
- name: CDN service
  description: Information about the current state of the CDN service in your account.
- name: CDN resources
- name: Origins
- name: Rules
  description: |-
    Rules allow to set up custom settings for certain file types or paths.
    By default, the rule inherits all options values from the related CDN resource.

    Each option in rule settings can be in one of the following states:
    - **Inherit** - Option is not added to the rule. Option inherits its value from the CDN resource settings. In this case, the option value is **null**.
    - **ON** - Option is added to the rule and enabled. Option values configured in the rule will override values from the CDN resource settings.
    - **OFF** - Option is added to the rule and disabled. Option will be turned off.
- name: Rule templates
- name: Presets
  description: |-
    A preset is a predefined set of CDN resource or rule settings that can be applied to an object in a single request.

    Once a preset is applied to an object, the options included in the preset cannot be edited on that object until the preset is unapplied.
- name: SSL certificates
- name: Let's Encrypt certificates
- name: CA certificates
- name: Aliases
  description: |-
    An alias is a hostname you own that is served with the settings of one of your CDN resources and with
    its own SSL certificate. Aliases must be enabled for your account.
- name: CDN activity logs
  description: |-
    Get the history of users requests to CDN.
    It contains requests made both via the API and via the control panel.

    The following methods are not tracked in the activity logs:
    - HEAD
    - OPTIONS
- name: Log viewer
  description: |-
    Log viewer provides you with general information about CDN operation. This information does not contain all possible
    sets of fields and restricted by time. To receive full data, use Logs Uploader.
- name: Logs uploader
  description: |-
    Logs uploader allows you to upload logs with desired format to desired storages.

    Consists of three main parts:
    - **Policies** - rules that define which logs are uploaded and how they are uploaded.
    - **Targets** - destinations where logs are uploaded.
    - **Configs** - combinations of logs uploader policies, targets and resources to which they are applied.
- name: Tools
- name: Statistics
  description: |-
    Consumption statistics is updated in near real-time as a standard practice.
    However, the frequency of updates can vary, but they are typically available within a 24-hour period.
    Exceptions, such as maintenance periods, may delay data beyond 24 hours until servers resume and fill in the missing statistics.
- name: Advanced analytics
  description: |-
    Advanced analytics allows to get statistics about unique visitors, traffic, and requests for countries, directories, browsers, devices, and operation systems for up to 90 days starting from today.

    Advanced analytics API is based on the [GraphQL framework](https://graphql.org/).

    Advanced analytics API has one single endpoint:

     https://api.gcore.com/cdn/advanced/v2/query

    You can pass the query parameters as a JSON object in the payload of a POST request to this endpoint.
    You can use curl to make requests to the Advanced analytics API. Alternatively, you can use a GraphQL client
    to construct queries and pass requests to the Advanced analytics API.

    You can write queries in GraphQL much like in SQL: specify the data set (CDN resource), the metrics
    to retrieve (such as unique visitors and traffic), and filter or group by dimensions (for example, a country).
- name: Origin shielding
- name: IP addresses list
- name: Purge history
paths:
  /cdn/public-ip-list:
    get:
      operationId: get-cdn-servers-ip-addresses
      tags:
      - IP addresses list
      summary: Get CDN servers IP addresses
      description: |-
        Get all IP addresses of CDN servers that can be used to pull content from your origin.

        This list is updated periodically. If you want to use IP from this list to configure IP ACL in your origin, you need to independently monitor its relevance.
        We recommend using a script to automatically update IP ACL.

        This request does not require authorization.
      parameters:
      - $ref: '#/components/parameters/format'
      - $ref: '#/components/parameters/accept'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetPublicIPList'
            text/plain:
              schema:
                type: string
                description: Plain text list of IP addresses, one per line.
              example: |
                198.51.100.10/32
                2001:db8::8/128
      security: []
      x-codeSamples:
      - lang: Python
        source: |-
          from gcore import Gcore

          client = Gcore()
          public_ip_list = client.cdn.ips.list()
          print(public_ip_list.addresses)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	publicIPList, err := client.CDN.IPs.List(context.TODO(), cdn.IPListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", publicIPList.Addresses)
          }
  /cdn/public-net-list:
    get:
      operationId: get-cdn-servers-networks
      tags:
      - IP addresses list
      summary: Get CDN servers networks
      description: |-
        Get all CDN networks that can be used to pull content from your origin.

        This list is updated periodically. If you want to use network from this list to configure IP ACL on your origin, you need to independently monitor its relevance.
        We recommend using a script for automatically update IP ACL.

        This request does not require authorization.
      parameters:
      - $ref: '#/components/parameters/format'
      - $ref: '#/components/parameters/accept'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetPublicNetworkList'
            text/plain:
              schema:
                type: string
                description: Plain text list of networks, one per line.
              example: |
                203.0.113.0/24
                2001:db8:1::/112
      security: []
      x-codeSamples:
      - lang: Python
        source: |-
          from gcore import Gcore

          client = Gcore()
          public_network_list = client.cdn.ip_ranges.list()
          print(public_network_list.addresses)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	publicNetworkList, err := client.CDN.IPRanges.List(context.TODO(), cdn.IPRangeListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", publicNetworkList.Addresses)
          }
  /cdn/clients/me:
    get:
      operationId: get-cdn-service-details
      tags:
      - CDN service
      summary: Get CDN service details
      description: Get information about CDN service.
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CDNServiceResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_account = client.cdn.get_account_overview()
          print(cdn_account.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnAccount, err := client.CDN.GetAccountOverview(context.TODO())
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnAccount.ID)
          }
    put:
      operationId: change-cdn-service
      tags:
      - CDN service
      summary: Change CDN service
      description: Change information about CDN service.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeCDNService'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CDNServiceResponse'
        '400':
          description: Invalid value of "utilization_level" parameter is provided.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UtilizationLevelCDNServiceError'
    patch:
      operationId: patch-cdn-service
      tags:
      - CDN service
      summary: Change CDN service
      description: Change information about CDN service.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeCDNService'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CDNServiceResponse'
        '400':
          description: Invalid value of "utilization_level" parameter is provided.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UtilizationLevelCDNServiceError'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_account = client.cdn.update_account()
          print(cdn_account.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnAccount, err := client.CDN.UpdateAccount(context.TODO(), cdn.CDNUpdateAccountParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnAccount.ID)
          }
  /cdn/clients/me/features:
    get:
      operationId: get-cdn-features-details
      tags:
      - CDN service
      summary: Get CDN features details
      description: Get information about available CDN features.
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ClientsMeFeaturesResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_available_features = client.cdn.get_available_features()
          print(cdn_available_features.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnAvailableFeatures, err := client.CDN.GetAvailableFeatures(context.TODO())
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnAvailableFeatures.ID)
          }
  /cdn/clients/me/limits:
    get:
      operationId: get-cdn-limits-details
      tags:
      - CDN service
      summary: Get CDN limits details
      description: Get information about CDN service limits.
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ClientsMeLimitsResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_account_limits = client.cdn.get_account_limits()
          print(cdn_account_limits.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnAccountLimits, err := client.CDN.GetAccountLimits(context.TODO())
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnAccountLimits.ID)
          }
  /cdn/origin_groups:
    get:
      operationId: get-origin-groups-list
      tags:
      - Origins
      summary: Get origin groups list
      description: Get all origin groups and related origin sources.
      parameters:
      - in: query
        name: name
        schema:
          type: string
        description: Origin group name.
      - in: query
        name: sources
        schema:
          type: string
        description: Origin sources (IP addresses or domains) in the origin group.
      - in: query
        name: has_related_resources
        schema:
          type: boolean
        description: |-
          Defines whether the origin group has related CDN resources.

          Possible values:
          - **true** – Origin group has related CDN resources.
          - **false** – Origin group does not have related CDN resources.
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OriginGroupsListResponse'
        '403':
          $ref: '#/components/responses/NoPermissions'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.origin_groups.list()
          page = page.results[0]
          print(page)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.OriginGroups.List(context.TODO(), cdn.OriginGroupListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
    post:
      operationId: create-origin-group
      description: Create an origin group with one or more origin sources.
      tags:
      - Origins
      summary: Create origin group
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateOriginGroup'
      responses:
        '201':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OriginGroupsResponse'
        '400':
          description: Failed to create the origin group.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateOriginGroupValidationError'
        '403':
          description: Forbidden to create the origin group.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/NoPermissionsWithExample'
                - $ref: '#/components/schemas/LimitsForCreationOriginsGroup'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          origin_groups = client.cdn.origin_groups.create(
              name="YourOriginGroup",
              sources=[{
                  "source": "origin.example.com"
              }],
          )
          print(origin_groups)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	originGroups, err := client.CDN.OriginGroups.New(context.TODO(), cdn.OriginGroupNewParams{
          		OfNoneAuth: &cdn.OriginGroupNewParamsBodyNoneAuth{
          			Name: "YourOriginGroup",
          			Sources: []cdn.OriginGroupNewParamsBodyNoneAuthSourceUnion{{
          				OfHostSource: &cdn.OriginGroupNewParamsBodyNoneAuthSourceHostSource{
          					Source: "origin.example.com",
          				},
          			}},
          		},
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", originGroups)
          }
  /cdn/origin_groups/{origin_group_id}:
    get:
      operationId: get-origin-group-details
      tags:
      - Origins
      summary: Get origin group details
      parameters:
      - in: path
        name: origin_group_id
        description: Origin group ID.
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OriginGroupsResponse'
        '403':
          $ref: '#/components/responses/NoPermissions'
        '404':
          $ref: '#/components/responses/OriginGroupNotFound'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          origin_groups = client.cdn.origin_groups.get(
              0,
          )
          print(origin_groups)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	originGroups, err := client.CDN.OriginGroups.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", originGroups)
          }
    put:
      operationId: change-origin-group
      tags:
      - Origins
      summary: Change origin group
      parameters:
      - in: path
        name: origin_group_id
        description: Origin group ID.
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeOriginGroupPut'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OriginGroupsResponse'
        '400':
          description: Failed to change the origin group.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChangeOriginGroupPutValidationError'
        '403':
          $ref: '#/components/responses/NoPermissions'
        '404':
          $ref: '#/components/responses/OriginGroupNotFound'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          origin_groups = client.cdn.origin_groups.replace(
              origin_group_id=0,
              name="YourOriginGroup",
              sources=[{
                  "source": "origin.example.org"
              }],
              use_next=True,
          )
          print(origin_groups)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	originGroups, err := client.CDN.OriginGroups.Replace(
          		context.TODO(),
          		0,
          		cdn.OriginGroupReplaceParams{
          			OfNoneAuth: &cdn.OriginGroupReplaceParamsBodyNoneAuth{
          				Name: "YourOriginGroup",
          				Sources: []cdn.OriginGroupReplaceParamsBodyNoneAuthSourceUnion{{
          					OfHostSource: &cdn.OriginGroupReplaceParamsBodyNoneAuthSourceHostSource{
          						Source: "origin.example.org",
          					},
          				}},
          				UseNext: true,
          			},
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", originGroups)
          }
    patch:
      operationId: patch-origin-group
      tags:
      - Origins
      summary: Change origin group
      parameters:
      - in: path
        name: origin_group_id
        description: Origin group ID.
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeOriginGroup'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OriginGroupsResponse'
        '400':
          description: Failed to change the origin group.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChangeOriginGroupValidationError'
        '403':
          $ref: '#/components/responses/NoPermissions'
        '404':
          $ref: '#/components/responses/OriginGroupNotFound'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          origin_groups = client.cdn.origin_groups.update(
              origin_group_id=0,
              name="YourOriginGroup",
          )
          print(origin_groups)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	originGroups, err := client.CDN.OriginGroups.Update(
          		context.TODO(),
          		0,
          		cdn.OriginGroupUpdateParams{
          			OfNoneAuth: &cdn.OriginGroupUpdateParamsBodyNoneAuth{
          				Name: "YourOriginGroup",
          			},
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", originGroups)
          }
    delete:
      operationId: delete-origin-group
      tags:
      - Origins
      summary: Delete origin group
      parameters:
      - in: path
        name: origin_group_id
        description: Origin group ID.
        required: true
        schema:
          type: integer
      responses:
        '204':
          description: Successful.
        '400':
          description: Failed to delete the origin group.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/OriginGroupIsUsedByResourceError'
                - $ref: '#/components/schemas/OriginGroupIsUsedByRulesError'
        '403':
          $ref: '#/components/responses/NoPermissions'
        '404':
          $ref: '#/components/responses/OriginGroupNotFound'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.origin_groups.delete(
              0,
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.OriginGroups.Delete(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/resources:
    get:
      operationId: get-cdn-resources-list
      tags:
      - CDN resources
      summary: Get CDN resources list
      description: Get information about all CDN resources in your account.
      parameters:
      - $ref: '#/components/parameters/deleted'
      - $ref: '#/components/parameters/enabled'
      - $ref: '#/components/parameters/originGroup'
      - $ref: '#/components/parameters/originGroup__in'
      - $ref: '#/components/parameters/sslEnabled'
      - $ref: '#/components/parameters/sslData'
      - $ref: '#/components/parameters/sslData_in'
      - $ref: '#/components/parameters/min_created'
      - $ref: '#/components/parameters/max_created'
      - $ref: '#/components/parameters/cname'
      - $ref: '#/components/parameters/secondaryHostnames'
      - $ref: '#/components/parameters/vp_enabled'
      - $ref: '#/components/parameters/rules'
      - $ref: '#/components/parameters/shielded'
      - $ref: '#/components/parameters/shield_dc'
      - $ref: '#/components/parameters/suspend'
      - $ref: '#/components/parameters/status'
      - $ref: '#/components/parameters/active'
      - $ref: '#/components/parameters/name'
      - $ref: '#/components/parameters/originProtocol'
      - $ref: '#/components/parameters/suspended'
      - $ref: '#/components/parameters/is_primary'
      - $ref: '#/components/parameters/waap_domain_id__isnull'
      - $ref: '#/components/parameters/min_updated'
      - $ref: '#/components/parameters/max_updated'
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResourceListResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.cdn_resources.list()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.CDNResources.List(context.TODO(), cdn.CDNResourceListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
    post:
      operationId: create-cdn-resource
      tags:
      - CDN resources
      summary: Create CDN resource
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateResource'
      responses:
        '201':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResourceResponse'
        '400':
          description: Failed to create the CDN resource.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/CnameAlreadyExistsError'
                - $ref: '#/components/schemas/SecondaryCnameAlreadyExistsError'
                - $ref: '#/components/schemas/JSONParseError'
                - $ref: '#/components/schemas/CommonValidationError'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_resource = client.cdn.cdn_resources.create(
              cname="cdn.example.com",
          )
          print(cdn_resource.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnResource, err := client.CDN.CDNResources.New(context.TODO(), cdn.CDNResourceNewParams{
          		Cname: "cdn.example.com",
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnResource.ID)
          }
  /cdn/resources/{resource_id}:
    get:
      operationId: get-cdn-resource-details
      tags:
      - CDN resources
      summary: Get CDN resource details
      parameters:
      - $ref: '#/components/parameters/resource_id'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResourceResponse'
        '404':
          description: CDN resource is not found.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_resource = client.cdn.cdn_resources.get(
              0,
          )
          print(cdn_resource.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnResource, err := client.CDN.CDNResources.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnResource.ID)
          }
    put:
      operationId: change-cdn-resource
      tags:
      - CDN resources
      summary: Change CDN resource
      parameters:
      - $ref: '#/components/parameters/resource_id'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeResource'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResourceResponse'
        '400':
          description: Failed to change the CDN resource.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/CannotLinkYourSSLCertificate'
        '404':
          description: CDN resource is not found.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_resource = client.cdn.cdn_resources.replace(
              resource_id=0,
              origin_group=132,
          )
          print(cdn_resource.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnResource, err := client.CDN.CDNResources.Replace(
          		context.TODO(),
          		0,
          		cdn.CDNResourceReplaceParams{
          			OriginGroup: 132,
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnResource.ID)
          }
    patch:
      operationId: patch-cdn-resource
      tags:
      - CDN resources
      summary: Change CDN resource
      parameters:
      - $ref: '#/components/parameters/resource_id'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchResource'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResourceResponse'
        '404':
          description: CDN resource is not found.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_resource = client.cdn.cdn_resources.update(
              resource_id=0,
          )
          print(cdn_resource.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnResource, err := client.CDN.CDNResources.Update(
          		context.TODO(),
          		0,
          		cdn.CDNResourceUpdateParams{},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnResource.ID)
          }
    delete:
      operationId: delete-cdn-resource
      tags:
      - CDN resources
      summary: Delete CDN resource
      description: |-
        Delete the CDN resource from the system permanently.

        Notes:
        - **Deactivation Requirement**: Set the `active` attribute to `false` before deletion.
        - **Statistics Availability**: Statistics will be available for **365 days** after deletion through the [statistics endpoints](/api-reference/cdn/cdn-statistics/cdn-resource-statistics).
        - **Irreversibility**: This action is irreversible. Once deleted, the CDN resource cannot be recovered.
      parameters:
      - $ref: '#/components/parameters/resource_id'
      responses:
        '204':
          description: Successful
        '400':
          description: Failed to delete the CDN resource.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/PrimaryResourceDeletionFailed'
                - $ref: '#/components/schemas/StreamingResourceDeletionFailed'
                - $ref: '#/components/schemas/FullCustomResourceDeletionFailed'
                - $ref: '#/components/schemas/ActiveInstanceDeletionProhibited'
        '404':
          $ref: '#/components/responses/ResourceNotFound'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.cdn_resources.delete(
              0,
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.CDNResources.Delete(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/activity_log/requests:
    get:
      operationId: get-activity-logs
      tags:
      - CDN activity logs
      summary: Get CDN activity logs
      description: Get information about all CDN activity logs records.
      parameters:
      - $ref: '#/components/parameters/path'
      - $ref: '#/components/parameters/user_id'
      - $ref: '#/components/parameters/token_id'
      - $ref: '#/components/parameters/client_id'
      - $ref: '#/components/parameters/method'
      - $ref: '#/components/parameters/min_requested_at'
      - $ref: '#/components/parameters/max_requested_at'
      - $ref: '#/components/parameters/remote_ip_address'
      - $ref: '#/components/parameters/status_code'
      - $ref: '#/components/parameters/limit-2'
      - $ref: '#/components/parameters/offset-2'
      responses:
        '200':
          $ref: '#/components/responses/List'
        '401':
          description: Authentication credentials were not provided or the given token is not valid for any token type.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.audit_logs.list()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.AuditLogs.List(context.TODO(), cdn.AuditLogListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
  /cdn/activity_log/requests/{log_id}:
    get:
      operationId: get-activity-logs-details
      tags:
      - CDN activity logs
      summary: Get CDN activity logs details
      description: Get information about CDN activity logs record.
      parameters:
      - $ref: '#/components/parameters/ID'
      responses:
        '200':
          $ref: '#/components/responses/Details'
        '401':
          description: Authentication credentials were not provided or the given token is not valid for any token type.
        '404':
          description: Activity logs record is not found.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          cdn_audit_log_entry = client.cdn.audit_logs.get(
              0,
          )
          print(cdn_audit_log_entry.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	cdnAuditLogEntry, err := client.CDN.AuditLogs.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", cdnAuditLogEntry.ID)
          }
  /cdn/advanced/v1/logs:
    get:
      operationId: get-cdn-logs
      tags:
      - Log viewer
      summary: Get CDN logs
      description: |-
        Get CDN logs for up to 3 days starting today.

        You can filter logs using query parameters by client IP, CDN resource, date, path and etc.

        To filter the CDN logs by 2xx status codes, use:
        - &`status__gte`=200&`status__lt`=300
      parameters:
      - $ref: '#/components/parameters/from'
      - $ref: '#/components/parameters/to'
      - $ref: '#/components/parameters/offset-3'
      - $ref: '#/components/parameters/limit-3'
      - $ref: '#/components/parameters/ordering'
      - $ref: '#/components/parameters/fields'
      - $ref: '#/components/parameters/method__eq'
      - $ref: '#/components/parameters/method__ne'
      - $ref: '#/components/parameters/method__in'
      - $ref: '#/components/parameters/method__not_in'
      - $ref: '#/components/parameters/client_ip__eq'
      - $ref: '#/components/parameters/client_ip__ne'
      - $ref: '#/components/parameters/client_ip__in'
      - $ref: '#/components/parameters/client_ip__not_in'
      - $ref: '#/components/parameters/status__gt'
      - $ref: '#/components/parameters/status__gte'
      - $ref: '#/components/parameters/status__lt'
      - $ref: '#/components/parameters/status__lte'
      - $ref: '#/components/parameters/status__eq'
      - $ref: '#/components/parameters/status__ne'
      - $ref: '#/components/parameters/status__in'
      - $ref: '#/components/parameters/status__not_in'
      - $ref: '#/components/parameters/size__gt'
      - $ref: '#/components/parameters/size__gte'
      - $ref: '#/components/parameters/size__lt'
      - $ref: '#/components/parameters/size__lte'
      - $ref: '#/components/parameters/size__eq'
      - $ref: '#/components/parameters/size__ne'
      - $ref: '#/components/parameters/size__in'
      - $ref: '#/components/parameters/size__not_in'
      - $ref: '#/components/parameters/cname__eq'
      - $ref: '#/components/parameters/cname__ne'
      - $ref: '#/components/parameters/cname__in'
      - $ref: '#/components/parameters/cname__not_in'
      - $ref: '#/components/parameters/cname__contains'
      - $ref: '#/components/parameters/resource_id__gt'
      - $ref: '#/components/parameters/resource_id__gte'
      - $ref: '#/components/parameters/resource_id__lt'
      - $ref: '#/components/parameters/resource_id__lte'
      - $ref: '#/components/parameters/resource_id__eq'
      - $ref: '#/components/parameters/resource_id__ne'
      - $ref: '#/components/parameters/resource_id__in'
      - $ref: '#/components/parameters/resource_id__not_in'
      - $ref: '#/components/parameters/cache_status__eq'
      - $ref: '#/components/parameters/cache_status__ne'
      - $ref: '#/components/parameters/cache_status__in'
      - $ref: '#/components/parameters/cache_status__not_in'
      - $ref: '#/components/parameters/datacenter__eq'
      - $ref: '#/components/parameters/datacenter__ne'
      - $ref: '#/components/parameters/datacenter__in'
      - $ref: '#/components/parameters/datacenter__not_in'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetLogsResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.logs.list(
              from_="from",
              to="to",
          )
          page = page.data[0]
          print(page.resource_id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.Logs.List(context.TODO(), cdn.LogListParams{
          		From: "from",
          		To:   "to",
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
  /cdn/advanced/v1/logs/download:
    get:
      operationId: download-cdn-logs
      tags:
      - Log viewer
      summary: Download CDN logs
      description: |-
        Download CDN logs for up to 3 days starting today.

        You can filter logs using query params by client IP, CDN resource, date, path and etc.
      parameters:
      - $ref: '#/components/parameters/from'
      - $ref: '#/components/parameters/to'
      - $ref: '#/components/parameters/offset-3'
      - in: query
        name: limit
        schema:
          type: integer
          default: 10000
          maximum: 10000
        description: Maximum number of log records in the response.
      - $ref: '#/components/parameters/method__eq'
      - $ref: '#/components/parameters/method__ne'
      - $ref: '#/components/parameters/method__in'
      - $ref: '#/components/parameters/method__not_in'
      - $ref: '#/components/parameters/client_ip__eq'
      - $ref: '#/components/parameters/client_ip__ne'
      - $ref: '#/components/parameters/client_ip__in'
      - $ref: '#/components/parameters/client_ip__not_in'
      - $ref: '#/components/parameters/status__gt'
      - $ref: '#/components/parameters/status__gte'
      - $ref: '#/components/parameters/status__lt'
      - $ref: '#/components/parameters/status__lte'
      - $ref: '#/components/parameters/status__eq'
      - $ref: '#/components/parameters/status__ne'
      - $ref: '#/components/parameters/status__in'
      - $ref: '#/components/parameters/status__not_in'
      - $ref: '#/components/parameters/size__gt'
      - $ref: '#/components/parameters/size__gte'
      - $ref: '#/components/parameters/size__lt'
      - $ref: '#/components/parameters/size__lte'
      - $ref: '#/components/parameters/size__eq'
      - $ref: '#/components/parameters/size__ne'
      - $ref: '#/components/parameters/size__in'
      - $ref: '#/components/parameters/size__not_in'
      - $ref: '#/components/parameters/cname__eq'
      - $ref: '#/components/parameters/cname__ne'
      - $ref: '#/components/parameters/cname__in'
      - $ref: '#/components/parameters/cname__not_in'
      - $ref: '#/components/parameters/cname__contains'
      - $ref: '#/components/parameters/resource_id__gt'
      - $ref: '#/components/parameters/resource_id__gte'
      - $ref: '#/components/parameters/resource_id__lt'
      - $ref: '#/components/parameters/resource_id__lte'
      - $ref: '#/components/parameters/resource_id__eq'
      - $ref: '#/components/parameters/resource_id__ne'
      - $ref: '#/components/parameters/resource_id__in'
      - $ref: '#/components/parameters/resource_id__not_in'
      - $ref: '#/components/parameters/cache_status__eq'
      - $ref: '#/components/parameters/cache_status__ne'
      - $ref: '#/components/parameters/cache_status__in'
      - $ref: '#/components/parameters/cache_status__not_in'
      - $ref: '#/components/parameters/datacenter__eq'
      - $ref: '#/components/parameters/datacenter__ne'
      - $ref: '#/components/parameters/datacenter__in'
      - $ref: '#/components/parameters/datacenter__not_in'
      - in: query
        name: sort
        schema:
          type: string
        description: |-
          Sorting rules.

          Possible values:
          - **method** - Request HTTP method.
          - **`client_ip`** - IP address of the client who sent the request.
          - **status** - Status code in the response.
          - **size** - Response size in bytes.
          - **cname** - Custom domain of the requested resource.
          - **`resource_id`** - ID of the requested CDN resource.
          - **`cache_status`** - Caching status.
          - **datacenter** - Data center where request was processed.
          - **timestamp** - Date and time when the request was made.

          May include multiple values separated by a comma.

          Example:
            - &sort=-timestamp,status
      - in: query
        name: fields
        schema:
          type: string
          default: timestamp,path,method,referer,user_agent,client_ip,status,size,cname,resource_id,cache_status,datacenter
        description: |-
          A comma-separated list of returned fields.

          Supported fields are presented in the responses section.

          Example:
            - &fields=timestamp,path,status
      - in: query
        name: format
        schema:
          type: string
        required: true
        description: |-
          Output format.

          Possible values:
          - csv
          - tsv
      responses:
        '200':
          content:
            application/zip:
              schema:
                type: string
                format: binary
          description: Successful.
          headers:
            content-disposition:
              schema:
                type: string
                format: attachment; filename=<from>_<to>_<format>.zip
              description: |-
                Result file name.

                "From" and "to" will be formatted according to RFC 5545.

                Example:
                - `20210614T000000_20210615T000000_tsv`.zip
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          response = client.cdn.logs.download(
              format="format",
              from_="from",
              to="to",
          )
          print(response)
          content = response.read()
          print(content)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	response, err := client.CDN.Logs.Download(context.TODO(), cdn.LogDownloadParams{
          		Format: "format",
          		From:   "from",
          		To:     "to",
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", response)
          }
  /cdn/logs_uploader/policies:
    get:
      operationId: get-policies-list
      tags:
      - Logs uploader
      summary: Get policies list
      description: Get list of logs uploader policies.
      parameters:
      - in: query
        name: search
        schema:
          type: string
        description: Search by policy name or id.
      - in: query
        name: config_ids
        schema:
          type: array
          items:
            type: integer
        description: Filter by ids of related logs uploader configs that use given policy.
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderPolicyListResponse'
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.logs_uploader.policies.list()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.LogsUploader.Policies.List(context.TODO(), cdn.LogsUploaderPolicyListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
    post:
      operationId: create-policy
      tags:
      - Logs uploader
      summary: Create policy
      description: Create logs uploader policy.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateLogsUploaderPolicy'
      responses:
        '201':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderPolicyResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_policy = client.cdn.logs_uploader.policies.create()
          print(logs_uploader_policy.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderPolicy, err := client.CDN.LogsUploader.Policies.New(context.TODO(), cdn.LogsUploaderPolicyNewParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderPolicy.ID)
          }
  /cdn/logs_uploader/policies/{id}:
    get:
      operationId: get-policy-details
      tags:
      - Logs uploader
      summary: Get policy details
      description: Get information about logs uploader policy.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderPolicyResponse'
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Policy do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_policy = client.cdn.logs_uploader.policies.get(
              0,
          )
          print(logs_uploader_policy.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderPolicy, err := client.CDN.LogsUploader.Policies.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderPolicy.ID)
          }
    put:
      operationId: change-policy
      tags:
      - Logs uploader
      summary: Change policy
      description: Change logs uploader policy.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateLogsUploaderPolicy'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderPolicyResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Policy do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_policy = client.cdn.logs_uploader.policies.replace(
              id=0,
          )
          print(logs_uploader_policy.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderPolicy, err := client.CDN.LogsUploader.Policies.Replace(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderPolicyReplaceParams{},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderPolicy.ID)
          }
    patch:
      operationId: patch-policy
      tags:
      - Logs uploader
      summary: Change policy
      description: Change logs uploader policy partially.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchLogsUploaderPolicy'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderPolicyResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Policy do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_policy = client.cdn.logs_uploader.policies.update(
              id=0,
          )
          print(logs_uploader_policy.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderPolicy, err := client.CDN.LogsUploader.Policies.Update(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderPolicyUpdateParams{},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderPolicy.ID)
          }
    delete:
      operationId: delete-policy
      tags:
      - Logs uploader
      summary: Delete policy
      description: |-
        Delete the logs uploader policy from the system permanently.

        Notes:
        - **Irreversibility**: This action is irreversible. Once deleted, the logs uploader policy cannot be recovered.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '204':
          description: Successful.
        '400':
          description: Policy cannot be deleted if it's assigned to any logs uploader config.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Policy do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.logs_uploader.policies.delete(
              0,
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.LogsUploader.Policies.Delete(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/logs_uploader/policies/fields:
    get:
      operationId: get-policy-fields
      tags:
      - Logs uploader
      summary: Get policy fields
      description: |-
        Get list of available fields for logs uploader policy.

        `/cdn/v2/logs_uploader/policies/fields` returns the same fields together with the conversion types each one permits.
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                type: array
                items:
                  type: string
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          response = client.cdn.logs_uploader.policies.list_fields()
          print(response)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	response, err := client.CDN.LogsUploader.Policies.ListFields(context.TODO())
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", response)
          }
  /cdn/v2/logs_uploader/policies/fields:
    get:
      operationId: get-policy-fields-v2
      tags:
      - Logs uploader
      summary: Get policy fields with allowed conversions
      description: |-
        Get the available fields for a logs uploader policy, each with the conversion types it permits in `field_conversions`.

        Supersedes `/cdn/logs_uploader/policies/fields`, which returns field names only.

        `-` is the placeholder for a skipped column: it may appear in `fields` and permits no conversion.
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/LogsUploaderPolicyField'
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_policy_fields = client.cdn.logs_uploader.policies.list_fields_allowed_conversions()
          print(logs_uploader_policy_fields)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderPolicyFields, err := client.CDN.LogsUploader.Policies.ListFieldsAllowedConversions(context.TODO())
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderPolicyFields)
          }
  /cdn/logs_uploader/targets:
    get:
      operationId: get-targets-list
      tags:
      - Logs uploader
      summary: Get targets list
      description: Get list of logs uploader targets.
      parameters:
      - in: query
        name: search
        schema:
          type: string
        description: Search by target name or id.
      - in: query
        name: config_ids
        schema:
          type: array
          items:
            type: integer
        description: Filter by ids of related logs uploader configs that use given target.
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderTargetListResponse'
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.logs_uploader.targets.list()
          page = page.results[0]
          print(page)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.LogsUploader.Targets.List(context.TODO(), cdn.LogsUploaderTargetListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
    post:
      operationId: create-target
      tags:
      - Logs uploader
      summary: Create target
      description: Create logs uploader target.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateLogsUploaderTarget'
      responses:
        '201':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderTargetResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_target = client.cdn.logs_uploader.targets.create(
              config={},
              storage_type="s3_gcore",
          )
          print(logs_uploader_target)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderTarget, err := client.CDN.LogsUploader.Targets.New(context.TODO(), cdn.LogsUploaderTargetNewParams{
          		OfS3Gcore: &cdn.LogsUploaderTargetNewParamsBodyS3Gcore{
          			Config: cdn.LogsUploaderTargetNewParamsBodyS3GcoreConfigUnion{
          				OfS3GcoreConfig: &cdn.LogsUploaderTargetNewParamsBodyS3GcoreConfigS3GcoreConfig{},
          			},
          		},
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderTarget)
          }
  /cdn/logs_uploader/targets/{id}:
    get:
      operationId: get-target-details
      tags:
      - Logs uploader
      summary: Get target details
      description: Get information about logs uploader target.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderTargetResponse'
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader target do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_target = client.cdn.logs_uploader.targets.get(
              0,
          )
          print(logs_uploader_target)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderTarget, err := client.CDN.LogsUploader.Targets.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderTarget)
          }
    put:
      operationId: change-target
      tags:
      - Logs uploader
      summary: Change target
      description: Change logs uploader target.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PutLogsUploaderTarget'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderTargetResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader target do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_target = client.cdn.logs_uploader.targets.replace(
              id=0,
              config={},
              storage_type="s3_gcore",
          )
          print(logs_uploader_target)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderTarget, err := client.CDN.LogsUploader.Targets.Replace(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderTargetReplaceParams{
          			OfS3Gcore: &cdn.LogsUploaderTargetReplaceParamsBodyS3Gcore{
          				Config: cdn.LogsUploaderTargetReplaceParamsBodyS3GcoreConfigUnion{
          					OfS3GcoreConfig: &cdn.LogsUploaderTargetReplaceParamsBodyS3GcoreConfigS3GcoreConfig{},
          				},
          			},
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderTarget)
          }
    patch:
      operationId: patch-target
      tags:
      - Logs uploader
      summary: Change target
      description: Change logs uploader target partially.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchLogsUploaderTarget'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderTargetResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader target do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_target = client.cdn.logs_uploader.targets.update(
              id=0,
          )
          print(logs_uploader_target)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderTarget, err := client.CDN.LogsUploader.Targets.Update(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderTargetUpdateParams{},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderTarget)
          }
    delete:
      operationId: delete-target
      tags:
      - Logs uploader
      summary: Delete target
      description: |-
        Delete the logs uploader target from the system permanently.

        Notes:
        - **Irreversibility**: This action is irreversible. Once deleted, the logs uploader target cannot be recovered.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '204':
          description: Successful.
        '400':
          description: Target cannot be deleted if it's assigned to any logs uploader config.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader target do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.logs_uploader.targets.delete(
              0,
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.LogsUploader.Targets.Delete(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/logs_uploader/targets/{id}/validate:
    post:
      operationId: validate-target
      tags:
      - Logs uploader
      summary: Validate target
      description: Validate logs uploader target.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderValidationResponse'
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader target do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_validation = client.cdn.logs_uploader.targets.validate(
              0,
          )
          print(logs_uploader_validation.code)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderValidation, err := client.CDN.LogsUploader.Targets.Validate(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderValidation.Code)
          }
  /cdn/logs_uploader/configs:
    get:
      operationId: get-configs-list
      tags:
      - Logs uploader
      summary: Get configs list
      description: Get list of logs uploader configs.
      parameters:
      - in: query
        name: search
        schema:
          type: string
        description: Search by config name or id.
      - in: query
        name: resource_ids
        schema:
          type: array
          items:
            type: integer
        description: Filter by ids of CDN resources that are assigned to given config.
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderConfigListResponse'
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.logs_uploader.configs.list()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.LogsUploader.Configs.List(context.TODO(), cdn.LogsUploaderConfigListParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
    post:
      operationId: create-config
      tags:
      - Logs uploader
      summary: Create config
      description: Create logs uploader config.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateLogsUploaderConfig'
      responses:
        '201':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderConfigResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_config = client.cdn.logs_uploader.configs.create(
              name="name",
              policy=0,
              target=0,
          )
          print(logs_uploader_config.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderConfig, err := client.CDN.LogsUploader.Configs.New(context.TODO(), cdn.LogsUploaderConfigNewParams{
          		Name:   "name",
          		Policy: 0,
          		Target: 0,
          	})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderConfig.ID)
          }
  /cdn/logs_uploader/configs/{id}:
    get:
      operationId: get-config-details
      tags:
      - Logs uploader
      summary: Get config details
      description: Get information about logs uploader config.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderConfigResponse'
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader config do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_config = client.cdn.logs_uploader.configs.get(
              0,
          )
          print(logs_uploader_config.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderConfig, err := client.CDN.LogsUploader.Configs.Get(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderConfig.ID)
          }
    put:
      operationId: change-config
      tags:
      - Logs uploader
      summary: Change config
      description: Change logs uploader config.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateLogsUploaderConfig'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderConfigResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader config do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_config = client.cdn.logs_uploader.configs.replace(
              id=0,
              name="name",
              policy=0,
              target=0,
          )
          print(logs_uploader_config.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderConfig, err := client.CDN.LogsUploader.Configs.Replace(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderConfigReplaceParams{
          			Name:   "name",
          			Policy: 0,
          			Target: 0,
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderConfig.ID)
          }
    patch:
      operationId: patch-config
      tags:
      - Logs uploader
      summary: Change config
      description: Change logs uploader config partially.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchLogsUploaderConfig'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderConfigResponse'
        '400':
          description: You will receive an error with the invalid parameter mentioned.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader config do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_config = client.cdn.logs_uploader.configs.update(
              id=0,
          )
          print(logs_uploader_config.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderConfig, err := client.CDN.LogsUploader.Configs.Update(
          		context.TODO(),
          		0,
          		cdn.LogsUploaderConfigUpdateParams{},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderConfig.ID)
          }
    delete:
      operationId: delete-config
      tags:
      - Logs uploader
      summary: Delete config
      description: |-
        Delete the logs uploader config from the system permanently.

        Notes:
        - **Irreversibility**: This action is irreversible. Once deleted, the logs uploader config cannot be recovered.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '204':
          description: Successful.
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader config do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.logs_uploader.configs.delete(
              0,
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.LogsUploader.Configs.Delete(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/logs_uploader/configs/{id}/validate:
    post:
      operationId: validate-config
      tags:
      - Logs uploader
      summary: Validate config
      description: Validate logs uploader config.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LogsUploaderValidationResponse'
        '403':
          description: Feature is disabled for your account.
        '404':
          description: Logs uploader config do not exist or has been deleted.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          logs_uploader_validation = client.cdn.logs_uploader.configs.validate(
              0,
          )
          print(logs_uploader_validation.code)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	logsUploaderValidation, err := client.CDN.LogsUploader.Configs.Validate(context.TODO(), 0)
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", logsUploaderValidation.Code)
          }
  /cdn/aws_regions:
    get:
      operationId: get-aws-regions-list
      tags:
      - Logs uploader
      summary: Get AWS regions list
      description: Get the list of Amazon AWS regions.
      parameters:
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetAwsRegionsResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.list_aws_regions()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.ListAwsRegions(context.TODO(), cdn.CDNListAwsRegionsParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
  /cdn/alibaba_regions:
    get:
      operationId: get-alibaba-regions-list
      tags:
      - Logs uploader
      summary: Get Alibaba regions list
      description: Get the list of Alibaba Cloud regions.
      parameters:
      - $ref: '#/components/parameters/limit'
      - $ref: '#/components/parameters/offset'
      responses:
        '200':
          description: Successful.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetAlibabaRegionsResponse'
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          page = client.cdn.list_alibaba_regions()
          page = page.results[0]
          print(page.id)
      - lang: Go
        source: |
          package main

          import (
          	"context"
          	"fmt"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	page, err := client.CDN.ListAlibabaRegions(context.TODO(), cdn.CDNListAlibabaRegionsParams{})
          	if err != nil {
          		panic(err.Error())
          	}
          	fmt.Printf("%+v\n", page)
          }
  /cdn/resources/{resource_id}/prefetch:
    post:
      operationId: prefetch-content
      tags:
      - Tools
      summary: Prefetch content
      description: |-
        Pre-populate files to a CDN cache before users requests. Prefetch is recommended only for files that **more than 200 MB** and **less than 5 GB**.

        You can make one prefetch request for a CDN resource per minute. One request for prefetch may content only up to 100 paths to files.

        The time of procedure depends on the number and size of the files.

        If you need to update files stored in the CDN, first purge these files and then prefetch.
      parameters:
      - $ref: '#/components/parameters/resource_id'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ResourcePrefetch'
      responses:
        '201':
          description: Successful.
        '400':
          description: Prefetch request validation is failed.
          content:
            application/json:
              schema:
                oneOf:
                - $ref: '#/components/schemas/IncorrectPathsItemsPurgeOrPrefetchError'
                - $ref: '#/components/schemas/JSONParseError'
        '429':
          description: You have exceeded number of allowed prefetch requests for your CDN resource.
      x-codeSamples:
      - lang: Python
        source: |-
          import os
          from gcore import Gcore

          client = Gcore(
              api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
          )
          client.cdn.cdn_resources.prefetch(
              resource_id=0,
              paths=["/test.jpg", "test1.jpg"],
          )
      - lang: Go
        source: |
          package main

          import (
          	"context"

          	"github.com/G-Core/gcore-go"
          	"github.com/G-Core/gcore-go/cdn"
          	"github.com/G-Core/gcore-go/option"
          )

          func main() {
          	client := gcore.NewClient(
          		option.WithAPIKey("My API Key"),
          	)
          	err := client.CDN.CDNResources.Prefetch(
          		context.TODO(),
          		0,
          		cdn.CDNResourcePrefetchParams{
          			Paths: []string{"/test.jpg", "test1.jpg"},
          		},
          	)
          	if err != nil {
          		panic(err.Error())
          	}
          }
  /cdn/resources/{resource_id}/purge:
    post:
      operationId: purge-cache
      tags:
      - Tools
      summary: Purge cache
      description: |-
        Delete cache from CDN servers. This is necessary to update CDN content.

        We have different limits for different purge types:
        - **Purge all cache** - One purge request for a CDN resource per minute.
        - **Purge by URL** - Two purge requests for a CDN resource per minute. One purge request is limited to 100 URLs.
[...]
